<?php
class zensms extends base 
{
    private $id_product = NULL;
    private $optOutActive = false;
    private $lang = "en";
    
    public function __construct()
    {
        global $db, $zco_notifier;

        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SMS_STATUS'");
        $check = !$check_query->EOF;
        
        if($check)
        {
            $zco_notifier->attach($this, array(
                'NOTIFY_HEADER_START_CREATE_ACCOUNT_SUCCESS', 
                'NOTIFY_CHECKOUT_PROCESS_HANDLE_AFFILIATES',
                'NOTIFIER_CART_ADD_CART_END', 
                'NOTIFIER_CART_REMOVE_END',
                'NOTIFY_ORDER_PROCESSING_STOCK_DECREMENT_END',
                'NOTIFY_ORDER_PROCESSING_STOCK_DECREMENT_BEGIN'
                ));  
            $this->hook();

            $result = $db->Execute("SELECT * FROM ".DB_PREFIX."products where products_model like 'OrderZenSMS' limit 1");

            if (!$result->EOF)
            {
                $this->id_product =  $result->fields["products_id"];
            }

            $result = $db->Execute("SELECT active FROM ".DB_PREFIX."sp_optout_prices limit 1");

            if (!$result->EOF)
            {
                $this->optOutActive =  $result->fields["active"];
            }
            
            $auto = $this->isAutoOptOut();
            
            if($auto == false && $this->optOutActive && !isset($_SESSION["SMS_IN_CART"]))
            {
                $_SESSION["SMS_IN_CART"] = false;
            } 
        }
    }
    
    public function update(&$class, $eventID, $paramsArray = array())
    {
        global $db;
        
        switch($eventID){
            case 'NOTIFY_HEADER_START_CREATE_ACCOUNT_SUCCESS':
                $hooks = new ModelSmsHooks();
                $hooks->customerAddHook(0, $_SESSION["customer_id"]);
            break;
            case 'NOTIFY_CHECKOUT_PROCESS_HANDLE_AFFILIATES':
                
                
                if($_SESSION['cart']->in_cart($this->id_product))
                {
                    $db->Execute("UPDATE ".DB_PREFIX."products SET products_quantity = 1000 WHERE products_id = ".$db->prepareInput($this->id_product));
                }
                
                $optOut = (($this->optOutActive)?($_SESSION["SMS_IN_CART"]):(true));
                
                $result = $db->Execute("SELECT orders_id FROM ".DB_PREFIX."orders WHERE customers_id = ".$_SESSION["customer_id"]." ORDER BY orders_id DESC LIMIT 1");

                if (!$result->EOF)
                {
                    while (!$result->EOF)
                    {
                        $order_id = $result->fields['orders_id'];
                        $result->MoveNext();
                    }
                }

                $hooks = new ModelSmsHooks();
                $hooks->orderAddHook($_SESSION["customer_id"], $order_id, $_SESSION['comments'], $optOut);
                
                unset($_SESSION["SMS_IN_CART"]);
                
                $this->outOfStock();
            break;
            case 'NOTIFIER_CART_ADD_CART_END':
                if($this->optOutActive)
                {
                    $this->optOutAdd();
                }
            break;
            case 'NOTIFIER_CART_REMOVE_END':
                if($this->optOutActive)
                {
                    $this->optOutRemove();
                }
            break;
        }
    }
    
    private function hook()
    {
        if((self::isFile("orders.php") || self::isFile("super_orders.php")) && self::checkAction("update_order"))
        {
            $hooks = new ModelSmsHooks();
            $hooks->changeOrderStatusHook($_POST["status"], "", $_GET["oID"]);
        }
        elseif(self::isFile("index.php") && self::checkAction("contact_us", "main_page") && self::checkAction("send"))
        {
            self::savePost();
        }    
        elseif(self::isFile("index.php") && $_GET["main_page"] == "contact_us" && $_GET["action"] == "success" && $_SESSION["zensms"]["hookPost"] != NULL)
        {
            $postSaved = self::restorePost();
            
            $hooks = new ModelSmsHooks();
            $hooks->contactFormHook(0, $postSaved["enquiry"], $postSaved["email"], $postSaved["name"]);
        }
        elseif(self::isFile("product.php") && self::checkAction("delete_product_confirm") && isset($_POST["products_id"]))
        {
            $hooks = new ModelSmsHooks();
            $hooks->productDeleteHook($_POST["products_id"]);
        }
    } 

    private static function checkSendForm($filename, $type = false, $sub = "hookPost")
    {
        $filename = "/".$filename;
        
        if($filename == strrchr($_SERVER["SCRIPT_NAME"],"/") && $type === true)
        {
            return true;
        }
        elseif($filename == strrchr($_SERVER["SCRIPT_NAME"],"/") && $type === false && $_SESSION["zensms"][$sub] != NULL)
        {
            return true;
        }
        elseif(isset($_REQUEST["action"]) && $filename == strrchr($_SERVER["SCRIPT_NAME"],"/") && $_REQUEST != NULL && $_REQUEST["action"] == $type)
        {
            return true;
        }
        elseif($_POST == NULL)
        {
            return false;
        }
        else
        {
            return false;   
        }
    }
    
    private static function checkAction($action, $type = "action")
    {
        if($action == NULL)
        {
            return false;
        }
        elseif(isset($_GET[$type]) && $action == $_GET[$type] && $_POST != NULL)
        {
            return true;
        }
        else
        {
            return false;
        }
    } 
    
    private static function savePost()
    {
        $_SESSION["zensms"]["hookPost"] = $_POST;
    }
        
    private static function saveValue($flagName, $flagValue)
    {
        if($flagName == "hookPost")
        {
            return false;
        }
        
        if(isset($flagName) && isset($flagValue))
        {
            $_SESSION["zensms"][$flagName] = $flagValue;
        }
        return false;
    }
    
    private static function restoreValue($flagName)
    {
        $value = $_SESSION["zensms"][$flagName];
        unset($_SESSION["zensms"][$flagName]);
        return $value;
    }
    
    static public function isEmail($email) 
    {
        return preg_match('|^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]{2,})+$|i', $email);
    }
        
    private static function isFile($filename)
    {
        $filename = "/".$filename;
        
        if($filename == strrchr($_SERVER["SCRIPT_NAME"],"/"))
        {
            return true;
        }
        return false;
    }
        
    private static function restorePost()
    {
        $post = $_SESSION["zensms"]["hookPost"];
        unset($_SESSION["zensms"]["hookPost"]);
        return $post;
    }
    
    private function isAutoOptOut()
    {
        global $db;
        
        $id_shop = 0;

        $result = $db->Execute("SELECT * FROM `" . DB_PREFIX . "sp_config` WHERE `shop_id` = '".$id_shop."' AND `config_name` = 'optout_auto'");

        if (!$result->EOF)
        {
            while (!$result->EOF)
            {
                return $row->fields["config_value"];
            }
        }
        return true;
    }
    
    private function optOutAdd()
    { 
        global $db;
        
        $auto = $this->isAutoOptOut();
                
        if($_SESSION['cart']->in_cart($this->id_product))
        {
            if(!$auto)
            {
                $_SESSION["SMS_IN_CART"] = true;
            }
        }
        
        if($this->id_product != NULL)
        {
            if(count($_SESSION["cart"]->contents)>0 && !$_SESSION['cart']->in_cart($this->id_product) && $_SESSION["SMS_IN_CART"] !== false)
            {
                if($auto)
                {
                    $_SESSION["cart"]->add_cart($this->id_product);
                    $_SESSION["SMS_IN_CART"] = true;
                }
            }
        }
            
        if(count($_SESSION["cart"]->contents)==1 && $_SESSION['cart']->in_cart($this->id_product))
        {
            if($auto)
            {
                $_SESSION["cart"]->remove($this->id_product); 
                unset($_SESSION["SMS_IN_CART"]);
            }
        }
    }
    
    private function optOutRemove()
    {
        if($this->id_product != NULL)
        {
            if(count($_SESSION["cart"]->contents)==1 && $_SESSION['cart']->in_cart($this->id_product))
            {
               $_SESSION["cart"]->remove($this->id_product); 
               unset($_SESSION["SMS_IN_CART"]);
            }

            if($_SESSION["SMS_IN_CART"] && !$_SESSION['cart']->in_cart($this->id_product))
            {
                $_SESSION["SMS_IN_CART"] = false;
            }

            if(!count($_SESSION["cart"]->contents))
            {
               unset($_SESSION["SMS_IN_CART"]); 
            }
        }
    }
    
    private function outOfStock()
    {
        global $db;
        
        $products = array();
        
        foreach($_SESSION["cart"]->contents as $key => $value)
        {
            if(strpos($key, ":"))
            {
                $products[] = substr($key, 0, strpos($key, ":"));
            }
            else
            {
                $products[] = $key;
            }
        }
        $hooks = new ModelSmsHooks();
        
        $products = $db->prepareInput(implode(", ", $products));

        $result = $db->Execute("SELECT * FROM ".DB_PREFIX."products WHERE products_id IN ($products) AND products_quantity < 1;");
        
        if(!$result->EOF)
        {
            while (!$result->EOF)
            {
                $this->productOutOfStockHook($result->fields["product_id"], 0, $result->fields["model"], $_SESSION["customer_id"], 0);
                $result->MoveNext();
            }
        }
    }
}
?>
